/*

<!-- Creative Commons License 
	<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">Creative Commons License</a>.
</Creative Commons License -->

*/

var current_index	= 1;
var num_frames		= 9;

var urlList = new Array();
var imgList = new Array();

var urlDisplay = new Array();

var timerPictureInterval= null;
var timerUpdateInterval	= null;

var pictureInterval	= 3000;
var updateInterval	= 1000*60*60;

var randomFrame;

var isUpdated = false;

// Setup the onshow and onhide functions
// setup an interval timer 
// Grab the data via setup() for the first time
function init() {
    
    createGenericButton(document.getElementById('doneButton'), 'Done', hideBack);
    
	if (window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
	}

	timerUpdateInterval = setInterval("setup()", updateInterval);
	
	setup();

}

function setup() {

	loadXMLDoc("http://alias.ouvaton.org/wp-dashr.php?cat=2");

}

// Setup the timer so if you keep the widget on display it will
// update itself every hour
function onShow() {

	setup();
	
    document.getElementById("messageBoard").innerHTML = "Loading";
    
	if (timerUpdateInterval == null) timerUpdateInterval = setInterval("setup()", updateInterval);

	if (timerPictureInterval == null) timerPictureInterval = setInterval("fadePic()", pictureInterval);
	
}

//
// Turn off our timer so the widget
// stops updating when hidden
function onHide() {

	if (timerUpdateInterval != null) { 
		clearInterval(timerUpdateInterval);
		timerUpdateInterval = null;
	} 

	if (timerPictureInterval != null) { 
		clearInterval(timerPictureInterval);
		timerPictureInterval = null; 
	}
}

function loadXMLDoc(url) {
   
    if (window.XMLHttpRequest) {
	    
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", url, true);
        req.setRequestHeader("Cache-Control", "no-cache"); 
        req.send(null);  

    } 

}

// handle onreadystatechange event of req object
function processReqChange() {

    // only if req shows "loaded"
    if (req.readyState == 4) {
        // only if "OK"
        if (req.status == 200) {
	        // If the XML was properly loaded then let's update the date
	        // field in the Widget
	        //
            currentDate();
            
            if(isUpdated) {
            
				//Parse url and img lists
				parseUrlList();
				parseImgList();
			   
				// Finally, let's (re)load our dashr
				displayImages();
				
				// and start interval to refresh pictures
				if (timerPictureInterval == null) 
				
				
				document.getElementById("messageBoard").innerHTML = "";
            
				timerPictureInterval = setInterval("fadePic()", pictureInterval);
            }
			
         } 
         
         else {   
            document.getElementById("messageBoard").innerHTML = "Unable to load data";            
           	alert("There was a problem retrieving the XML data:\n" + req.statusText);
        }
    }

}

function currentDate() {

	// Map our numerical instances of months to proper names
	//
	var month = new Array;
	month[0] = 'January';
	month[1] = 'February';
	month[2] = 'March';
	month[3] = 'April';
	month[4] = 'May';
	month[5] = 'June';
	month[6] = 'July';
	month[7] = 'August';
	month[8] = 'September';
	month[9] = 'October';
	month[10] = 'November';
	month[11] = 'December';
	
	// Since we're grabbing an HTML page we can't treat it like XML
	// We can look at the "responseText" and do regExp searches
	// responseXML is unfortunately undefined in this case
	//
	var response = req.responseText;

	// Match for the date ... 
	//
	var regExp = /\w{3},.*\+0000/ig;
	var result = response.match(regExp);
	
	// Make the date a little more reader friendly ... 
	//
	var displayDate = new Date(result);
	
	if(document.getElementById("dayDate").innerHTML == displayDate.getDate()) {
		isUpdated = false;
	}
	else {
		isUpdated = true;
		document.getElementById("dayDate").innerHTML = displayDate.getDate();
		document.getElementById("monthDate").innerHTML = month[displayDate.getMonth()];
	
	}

}

function parseUrlList() {

	var response = req.responseText;
	
	var urlPattern = /(http:\/\/www.flickr.com\/photos\/[^\s]*\/[^\s]*\/)/ig;
	
	urlList = response.match(urlPattern);
}

function parseImgList() {

	var response = req.responseText;

	var imgPattern = /(http:\/\/[^\s]*_s.jpg)/ig;
	
	imgList = response.match(imgPattern);
}

function wrapURL (theURL) 
{ 
     if (window.widget) 
	 {
          theURL = "javascript:widget.openURL('" + theURL + "');"; 
     } 
     return theURL; 
}

function displayImages() 
{	
	for(i = 1; i < num_frames; i++)
	{
		urlDisplay[i] = urlList[i];
		document.getElementById("img" + i).src = imgList[i];
		current_index++;
	}
}

function openPic(i)
{
	widget.openURL(urlDisplay[i]);
}

function goAlias()
{
	widget.openURL("http://alias.ouvaton.org");
}

function fadePic()
{
	randomFrame = Math.floor(Math.random()*num_frames);

	urlDisplay[randomFrame] = urlList[current_index];
	document.getElementById("img" + randomFrame).src = imgList[current_index];
	
	current_index++;
	
	if(current_index >= urlList.length) current_index = 1;
}


/* default widget stuff */

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";

	exitflip(event);
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack()
{
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}
